---
title: 'CSS Flexbox Inspector: Examine Flexbox layouts'
slug: Tools/Page_Inspector/How_to/Examine_Flexbox_layouts
tags:
  - Guide
  - Inspector
  - Tools
  - flexbox
---
<div>{{ToolsSidebar}}</div>

<p class="summary">The <strong>Flexbox Inspector</strong> allows you to examine <a href="/en-US/docs/Web/CSS/CSS_Flexible_Box_Layout">CSS Flexbox Layouts</a> using the Firefox DevTools, which is useful for discovering flex containers on a page, examining and modifying them, debugging layout issues, and more.</p>

<h2 id="Discovering_Flex_Containers">Discovering Flex Containers</h2>

<p>When an HTML element on your page has <code><a href="/en-US/docs/Web/CSS/display">display: flex</a></code> applied to it, a number of features are made available in the DevTools to provide easy access to Flexbox layout features.</p>

<h3 id="In_the_HTML_pane">In the HTML pane</h3>

<p>In the <a href="/en-US/docs/Tools/Page_Inspector/UI_Tour#HTML_pane">HTML Pane</a>, an element laid out with Flexbox has the word <code>flex</code> next to it as shown in the following image:</p>

<p><img alt="Indicators in the inspector showing an element is a flex container" src="https://mdn.mozillademos.org/files/17099/html-pane.png" style="height: 512px; width: 672px;"></p>

<p>Click the word <code>flex</code> in the HTML pane to keep the overlay visible when you move the mouse away from the container.</p>

<h3 id="In_the_infobar">In the infobar</h3>

<p>When you hover over an element in the HTML pane, you will see a tooltip that gives you more information about the element. When you hover over a flex container or flex item, the tooltip includes the appropriate information.</p>

<p>This header is a flex container:</p>

<p><img alt="Tooltip showing element is a flex container" src="https://mdn.mozillademos.org/files/17101/infobar-cont.png" style="display: block; height: 72px; margin: 0px auto; width: 672px;">Each navbar link is a flex item:</p>

<p><img alt="Tooltip showing an element is a flex item" src="https://mdn.mozillademos.org/files/17102/infobar-item.png" style="display: block; height: 72px; margin: 0px auto; width: 672px;"></p>

<p>The <code>nav</code> element within the header is both a flex item and a flex container which holds the navigation links:</p>

<p><img alt="Tooltip showing an element is both a flex container and a flex item" src="https://mdn.mozillademos.org/files/17100/infobar-both.png" style="display: block; height: 72px; margin: 0px auto; width: 672px;"></p>

<h3 id="In_the_CSS_pane">In the CSS pane</h3>

<p>In the <a href="/en-US/docs/Tools/Page_Inspector/UI_Tour#CSS_pane">CSS pane</a>'s Rules view, any instance of a <code><a href="/en-US/docs/Web/CSS/display">display: flex</a></code> declaration gets a small Flexbox icon <img alt="" src="https://mdn.mozillademos.org/files/16345/flexbox_icon.gif" style="height: 15px; width: 17px;"> next to the word <code>flex</code>.</p>

<p><img alt="The CSS pane of the Firefox devtools, showing the CSS for a flex container with an icon to toggle the Flexbox overly" src="https://mdn.mozillademos.org/files/17096/css-pane.png" style="display: block; height: 308px; margin: 0px auto; width: 360px;"></p>

<p>Clicking the icon toggles the display of an overlay on the page, which appears over the selected flex container that displays an outline around each flex item:</p>

<p><img alt="Flexbox overlay showing a flex container and its children" src="https://mdn.mozillademos.org/files/17104/overlay.png" style="display: block; height: 342px; margin: 0px auto; width: 672px;"></p>

<p>The overlay will still be shown when you select other elements from the Inspector panel, so you can edit related CSS properties and see how the flex items are affected by your changes.</p>

<h3 id="The_Layout_Flex_Container_section">The Layout Flex Container section</h3>

<p>The CSS pane's Layout view includes a collapsible "Flex Container" section. If you expand the section without selecting a flexbox container, it will only display the message, "Select a Flex container or item to continue". Once you select an element whose display is defined as flex, the panel will include a number of options for viewing details about the flex container and flex items within it. You can find out more about those in the section below.</p>

<div class="note">
<p><strong>Note</strong>: The Layout view can be found underneath the <em>Layout</em> tab on the right-hand pane of the Page Inspector. The above and below screenshots should give you further hints on how to get to this.</p>
</div>

<h2 id="Flex_Container_options">Flex Container options</h2>

<p>The Flex Container section of the Layout view looks like this:</p>

<p><img alt="Layout pane in Firefox Devtools showing options for the flexbox overlay" src="https://mdn.mozillademos.org/files/17097/flex-cont.png" style="border-style: solid; border-width: 1px; display: block; height: 371px; margin: 0px auto; width: 360px;"></p>

<p>There are two settings you can change in the Flex Container section:</p>

<ul>
 <li>You can control the color of the overlay by clicking on the small circle next to the selector. This will toggle a color picker so you can select a different color for the overlay.</li>
 <li>The switch on the right-hand side of the Flex Container section will also toggle the overlay on and off.</li>
</ul>

<h2 id="Flex_item_properties">Flex item properties</h2>

<p>The flex items within the flex container are displayed as a numbered list in the Flex Items section. Each entry displays the item's selector. Hover over an element to highlight it on the page.</p>

<p><img alt="List of flex items displayed in the Layout pane of Firefox Devtools" src="https://mdn.mozillademos.org/files/17098/flex-items.png" style="border: 1px solid black; display: block; height: 121px; margin: 0px auto; width: 250px;"></p>

<p>If you click on the item, the display shifts to show details about that element:</p>

<p><img alt="Details of flex item sizing in the Layout pane of Firefox DevTools" src="https://mdn.mozillademos.org/files/17103/item-details.png" style="border: 1px solid black; display: block; height: 303px; margin: 0px auto; width: 360px;"></p>

<p>This view shows information about the calculations for the size of the selected flex item:</p>

<ul>
 <li>A diagram visualizing the sizing of the flex item</li>
 <li>Content Size - the size of the component without any restraints imposed on it by its parent</li>
 <li>Flexibility - how much a flex item grew or shrunk based on its flex-grow value when there is extra free space or its flex-shrink value when there is not enough space</li>
 <li>Minimum Size (only appears when an item is clamped to its minimum size) - the minimum content size of a flex item when there is no more free space in the flex container</li>
 <li>Final Size - the size of the flex item after all sizing constraints imposed on it have been applied (based on the values of flex-grow, flex-shrink and flex-basis)</li>
</ul>

<p>At the top of the section is a drop-down list of all the items in the selected flexbox container:</p>

<p><img alt="Dropdown in Layout pane that allows you to select between different flex children" src="https://mdn.mozillademos.org/files/17105/select-items.png" style="border: 1px solid black; display: block; height: 273px; margin: 0px auto; width: 360px;"></p>

<p>You can use this drop-down to select any of the other flex items in the flex container.</p>
